diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java
index 1d4331d20..0cea76c87 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registry.java
@@ -3,6 +3,8 @@ package net.minecraft.core.data.registry;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.IntTag;
 import com.mojang.nbt.tags.Tag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 
 import java.util.*;
 
@@ -163,16 +165,16 @@ public class Registry<T>
         }
     }
 
-    public static Map<Integer, String> readIdMapFromTag(CompoundTag tag)
+    public static Int2ObjectMap<String> readIdMapFromTag(CompoundTag tag)
     {
-        Map<Integer, String> map = new HashMap<>();
+        Int2ObjectMap<String> map = new Int2ObjectArrayMap<>();
 
         for (Map.Entry<String, Tag<?>> entry : tag.getValue().entrySet())
         {
             if (!(entry.getValue() instanceof IntTag)) continue;
 
             IntTag iTag = (IntTag) entry.getValue();
-            map.put(iTag.getValue(), entry.getKey());
+            map.put(iTag.getValue().intValue(), entry.getKey());
         }
 
         return map;
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
index 08628163d..6d0b22d96 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
@@ -36,9 +36,9 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
             String key = obj.get("key").getAsString();
             try {
                 if (key.startsWith("tile.")){
-                    item = Item.itemsList[Blocks.keyToIdMap.get(key)];
+                    item = Item.itemsList[Blocks.keyToIdMap.getInt(key)];
                 } else if (key.startsWith("item.")){
-                    item = Item.itemsList[Item.nameToIdMap.get(key)];
+                    item = Item.itemsList[Item.nameToIdMap.getInt(key)];
                 } else {
                     throw new IllegalArgumentException("Item keys must either start with 'tile' or 'item' provided key '" + key + "' does not!");
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java
index 579e940ce..1962f2bbe 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryMapDuplication.java
@@ -26,9 +26,9 @@ public class RecipeEntryMapDuplication extends RecipeEntryCraftingDynamic{
             if (s != null)
             {
                 Item item = s.getItem();
-                if (item == Items.MAP) {
+                if (item == Items.MAP && ItemMap.hasInitialized(s)) {
                     map = s;
-                } else if (item == Items.PAPER) {
+                } else if (item == Items.MAP && !ItemMap.hasInitialized(s)) {
                     paperAmount++;
                 }
             }
@@ -63,12 +63,12 @@ public class RecipeEntryMapDuplication extends RecipeEntryCraftingDynamic{
                 if(stack == null) {
                     continue;
                 }
-                if(stack.itemID == Items.MAP.id) {
+                if(stack.itemID == Items.MAP.id && ItemMap.hasInitialized(stack)) {
                     if(mapStack != null) {
                         return false;
                     }
                     mapStack = stack;
-                } else if(stack.itemID == Items.PAPER.id){
+                } else if(stack.itemID == Items.MAP.id && !ItemMap.hasInitialized(stack)){
                     hasPaper = true;
                 }else {
                     return false;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index 74a64f93d..48c24361f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -1,6 +1,13 @@
 package net.minecraft.core.entity;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMaps;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.entity.animal.*;
 import net.minecraft.core.entity.monster.*;
 import net.minecraft.core.entity.player.Player;
@@ -27,9 +34,9 @@ public final class EntityDispatcher
     public static final Map<NamespaceID, Class<? extends Entity>> idToClassMap = new HashMap<>();
     public static final Map<String, Class<? extends Entity>> stringIdToClassMap = new HashMap<>();
 
-    private static final Map<Integer, Class<? extends Entity>> numericIdToClassMap = new HashMap<>();
-    private static final Map<Integer, String> numericIdToStringIdMap = new HashMap<>();
-    private static final Map<Class<? extends Entity>, Integer> classToNumericIdMap = new HashMap<>();
+    private static final Int2ObjectMap<Class<? extends Entity>> numericIdToClassMap = new Int2ObjectOpenHashMap<>();
+    private static final Int2ObjectMap<String> numericIdToStringIdMap = new Int2ObjectOpenHashMap<>();
+    private static final Object2IntMap<Class<? extends Entity>> classToNumericIdMap = new Object2IntOpenHashMap<>();
 
     private static final Map<Class<? extends Entity>, String> classToNameKeyMap = new HashMap<>();
 
@@ -82,28 +89,28 @@ public final class EntityDispatcher
         return classToNumericIdMap.getOrDefault(entityClass, -1);
     }
 
-    public static void setNumericIds(Map<Integer, String> mapping) {
+    public static void setNumericIds(final @NotNull Int2ObjectMap<String> mapping) {
         numericIdToClassMap.clear();
         numericIdToStringIdMap.clear();
         classToNumericIdMap.clear();
-        for (Map.Entry<Integer, String> entry : mapping.entrySet()) {
-            Class<? extends Entity> entityClass = classForId(entry.getValue());
+        for (final Int2ObjectMap.Entry<String> entry : mapping.int2ObjectEntrySet()) {
+            final Class<? extends Entity> entityClass = classForId(entry.getValue());
             if (entityClass == null) {
                 LOGGER.error("Could not find entityClass assigned to namespace id {}! Skipping!", entry.getValue());
                 continue;
             }
 
-            numericIdToClassMap.put(entry.getKey(), entityClass);
-            numericIdToStringIdMap.put(entry.getKey(), entry.getValue());
-            classToNumericIdMap.put(entityClass, entry.getKey());
+            numericIdToClassMap.put(entry.getIntKey(), entityClass);
+            numericIdToStringIdMap.put(entry.getIntKey(), entry.getValue());
+            classToNumericIdMap.put(entityClass, entry.getIntKey());
 
-            if (entry.getKey() >= mappingCount) {
-                mappingCount = entry.getKey() + 1;
+            if (entry.getIntKey() >= mappingCount) {
+                mappingCount = entry.getIntKey() + 1;
             }
         }
     }
 
-    public static Map<Integer, String> getEntityIds() {
+    public static Int2ObjectMap<String> getEntityIds() {
         return numericIdToStringIdMap;
     }
 
@@ -229,8 +236,8 @@ public final class EntityDispatcher
     public static class Legacy {
         public static final Map<String, Class<? extends Entity>> keyToClassMap = new HashMap<>();
         public static final Map<Class<? extends Entity>, String> classToKeyMap = new HashMap<>();
-        private static final Map<Integer, Class<? extends Entity>> idToClassMap = new HashMap<>();
-        private static final Map<Class<? extends Entity>, Integer> classToIdMap = new HashMap<>();
+        private static final Int2ObjectMap<Class<? extends Entity>> idToClassMap = new Int2ObjectArrayMap<>();
+        private static final Object2IntMap<Class<? extends Entity>> classToIdMap = new Object2IntArrayMap<>();
 
         private static int maxIdSize = 0;
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
index 0676c72b1..26e40d478 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.entity.animal;
 
 import com.mojang.nbt.tags.CompoundTag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.Global;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.block.Block;
@@ -29,7 +31,7 @@ import java.util.Set;
 import java.util.function.Supplier;
 
 public class MobButterfly extends MobFlying implements AmbientCreature {
-    public static final Map<Integer, ButterflyEntry> colorEntries = new HashMap<>();
+    public static final Int2ObjectMap<ButterflyEntry> colorEntries = new Int2ObjectArrayMap<>();
 
     public static final int DATA_COLOR_ID = 16;
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
index a2f44f0f9..145551dd7 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.entity.animal;
 
 import com.mojang.nbt.tags.CompoundTag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
@@ -432,7 +434,7 @@ public class MobFireflyCluster extends MobFlying
 	}
 
 	public static class FireflyColor {
-		public static Map<Integer, FireflyColor> fireFlyColors = new HashMap<>();
+		public static Int2ObjectMap<FireflyColor> fireFlyColors = new Int2ObjectArrayMap<>();
 		public static FireflyColor GREEN = register(new FireflyColor(0, "fireflyGreen", new Biome[] {
 				Biomes.OVERWORLD_RAINFOREST,
 				Biomes.OVERWORLD_SWAMPLAND,
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
index 2a3423f1e..bcb1a9ca6 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.entity.monster;
 
 import com.mojang.nbt.tags.CompoundTag;
+import it.unimi.dsi.fastutil.ints.IntArrayList;
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.IItemHolding;
@@ -41,7 +43,7 @@ public class MobZombieArmored extends MobZombie implements IItemHolding
         super.spawnInit();
         Random rand = new Random();
         setHoldingSword(rand.nextInt(5)==0);
-        List<Integer> armorItems = new ArrayList<>();
+        IntList armorItems = new IntArrayList();
         armorItems.add(0);
         armorItems.add(1);
         armorItems.add(2);
@@ -50,8 +52,8 @@ public class MobZombieArmored extends MobZombie implements IItemHolding
         for (int i = 0; i < 4; i++)
         {
             int index = rand.nextInt(armorItems.size());
-            armorBreakOrder[i] = armorItems.get(index);
-            armorItems.remove(index);
+            armorBreakOrder[i] = armorItems.getInt(index);
+            armorItems.removeInt(index);
         }
         setArmorBreakOrder(armorBreakOrder);
         int[] armorBreakPoints = new int[4];
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index a2208d855..bc62d1e4a 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.item;
 
 import com.mojang.nbt.tags.CompoundTag;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatItem;
 import net.minecraft.core.achievement.stat.StatList;
@@ -34,7 +36,7 @@ import java.util.function.Supplier;
 public class Item implements ITaggable<Item>, IItemConvertible
 {
     protected static final Random itemRand = new Random();
-    public static final Map<String, Integer> nameToIdMap = new HashMap<>();
+    public static final Object2IntMap<String> nameToIdMap = new Object2IntOpenHashMap<>();
 
     public static final @Nullable Item @NotNull [] itemsList = new Item[32768];
     public static final Map<NamespaceID, Item> itemsMap = new LinkedHashMap<>();
@@ -53,19 +55,19 @@ public class Item implements ITaggable<Item>, IItemConvertible
 
     // Made this take an actual NamespaceID in the constructor to actually throw errors for modders when they update their mods, otherwise would be mistaken for the old lang key + item id constructor
 
-    public Item(NamespaceID namespaceId, int id)
+    public Item(final NamespaceID namespaceId, final int id)
     {
-        maxStackSize = 64;
-        maxDamage = 0;
-        hasSubtypes = false;
-        containerItem = null;
+        this.maxStackSize = 64;
+        this.maxDamage = 0;
+        this.hasSubtypes = false;
+        this.containerItem = null;
         this.id = id;
         this.namespaceID = namespaceId.makePermanent();
         if (itemsList[id] != null) {
             throw new IllegalArgumentException("Item slot '" + id + "' is already occupied by '" + itemsList[id] + "' when adding " + this);
         }
         if (itemsMap.containsKey(this.namespaceID)){
-            throw new IllegalArgumentException("Item id '" + namespaceID + "' is already used by '" + itemsMap.get(this.namespaceID) + "' when adding " + this);
+            throw new IllegalArgumentException("Item id '" + this.namespaceID + "' is already used by '" + itemsMap.get(this.namespaceID) + "' when adding " + this);
         }
 
         itemsList[this.id] = this;
@@ -74,39 +76,39 @@ public class Item implements ITaggable<Item>, IItemConvertible
         if (this.id > highestItemId)
             highestItemId = this.id;
     }
-    public Item(String translationKey, String namespaceId, int id)
+    public Item(final String translationKey, final String namespaceId, final int id)
     {
         this(makeNamespaceID(namespaceId), id);
         setKey(translationKey);
     }
 
-    private static NamespaceID makeNamespaceID(String string){ // This exists because java is idiotic
+    private static NamespaceID makeNamespaceID(final String string){ // This exists because java is idiotic
         try {
             return NamespaceID.getPermanent(string);
-        } catch (HardIllegalArgumentException e) {
+        } catch (final HardIllegalArgumentException e) {
             throw new IllegalArgumentException(e);
         }
     }
-    public Stat createStat(String statID, String nameKey){
+    public Stat createStat(final String statID, final String nameKey){
         if (getStat(statID) != null) return getStat(statID);
 
         Stat stat;
-        if (StatList.replacementMap.containsKey(id)){
-            Item replaceItem = Item.getItem(StatList.replacementMap.get(id));
+        if (StatList.replacementMap.containsKey(this.id)){
+            final Item replaceItem = Item.getItem(StatList.replacementMap.get(this.id));
             stat = replaceItem.getStat(statID);
             if (stat == null){
                 stat = replaceItem.createStat(statID, nameKey);
             }
         } else {
-            stat = new StatItem(NamespaceID.getPermanent(namespaceID.namespace(), namespaceID.value() + "_" + statID), nameKey, id).registerStat();
+            stat = new StatItem(NamespaceID.getPermanent(this.namespaceID.namespace(), this.namespaceID.value() + "_" + statID), nameKey, this.id).registerStat();
         }
 
         putStat(statID, stat);
         return stat;
     }
 
-    public void putStat(String statID, Stat stat){
-        stats.put(statID, stat);
+    public void putStat(final String statID, final Stat stat){
+        this.stats.put(statID, stat);
         statsInCategory.putIfAbsent(statID, new ArrayList<>());
         if (!statsInCategory.get(statID).contains(stat)){
             statsInCategory.get(statID).add(stat);
@@ -114,31 +116,31 @@ public class Item implements ITaggable<Item>, IItemConvertible
     }
 
     @Nullable
-    public Stat getStat(String statID){
-        return stats.get(statID);
+    public Stat getStat(final String statID){
+        return this.stats.get(statID);
     }
 
-    public Item setStatParent(@NotNull Supplier<@NotNull IItemConvertible> icon){
+    public Item setStatParent(@NotNull final Supplier<@NotNull IItemConvertible> icon){
         this.statParent = icon;
         return this;
     }
 
     @Nullable
     public Item getStatParent(){
-        if (statParent != null){
-            return statParent.get().asItem();
+        if (this.statParent != null){
+            return this.statParent.get().asItem();
         }
         return null;
     }
 
     @Nullable
-    public static List<Stat> getStats(String statID){
+    public static List<Stat> getStats(final String statID){
         return statsInCategory.get(statID);
     }
 
-    public Item withTags(Tag<Item>... tags)
+    public Item withTags(final Tag<Item>... tags)
     {
-        for (Tag<Item> tag : tags)
+        for (final Tag<Item> tag : tags)
         {
             tag.tag(this);
         }
@@ -146,46 +148,46 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return this;
     }
 
-    public boolean hasTag(Tag<Item> tag)
+    public boolean hasTag(final Tag<Item> tag)
     {
         return tag.appliesTo(this);
     }
 
-    public Item setMaxStackSize(int maxStackSize)
+    public Item setMaxStackSize(final int maxStackSize)
     {
         this.maxStackSize = maxStackSize;
         return this;
     }
 
-    public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(@NotNull final ItemStack itemstack, @Nullable final Player player, @NotNull final World world, final int blockX, final int blockY, final int blockZ, @NotNull final Side side, final double xPlaced, final double yPlaced)
     {
         return false;
     }
 
-    public void onUseByActivator(ItemStack itemStack, TileEntityActivator activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+    public void onUseByActivator(final ItemStack itemStack, final TileEntityActivator activatorBlock, final World world, final Random random, final int blockX, final int blockY, final int blockZ, final double offX, final double offY, final double offZ, final Direction direction) {
     }
 
-    public float getStrVsBlock(ItemStack itemstack, Block<?> block)
+    public float getStrVsBlock(final ItemStack itemstack, final Block<?> block)
     {
         return 1.0F;
     }
 
-    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    public ItemStack onUseItem(final ItemStack itemstack, final World world, final Player entityplayer)
     {
         return itemstack;
     }
 
-    public int getItemStackLimit(@Nullable ItemStack itemStack)
+    public int getItemStackLimit(@Nullable final ItemStack itemStack)
     {
-        return maxStackSize;
+        return this.maxStackSize;
     }
     
     public boolean getHasSubtypes()
     {
-        return hasSubtypes;
+        return this.hasSubtypes;
     }
 
-    protected Item setHasSubtypes(boolean hasSubtypes)
+    protected Item setHasSubtypes(final boolean hasSubtypes)
     {
         this.hasSubtypes = hasSubtypes;
         return this;
@@ -196,23 +198,23 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return getMaxDamageForStack(null);
     }
 
-    public int getMaxDamageForStack(@Nullable ItemStack itemStack)
+    public int getMaxDamageForStack(@Nullable final ItemStack itemStack)
     {
-        return maxDamage;
+        return this.maxDamage;
     }
 
-    protected Item setMaxDamage(int i)
+    protected Item setMaxDamage(final int i)
     {
-        maxDamage = i;
+        this.maxDamage = i;
         return this;
     }
 
     public boolean isDamagable()
     {
-        return maxDamage > 0 && !hasSubtypes;
+        return this.maxDamage > 0 && !this.hasSubtypes;
     }
 
-    public boolean hitEntity(ItemStack itemstack, Mob target, Mob attacker)
+    public boolean hitEntity(final ItemStack itemstack, final Mob target, final Mob attacker)
     {
         return false;
     }
@@ -220,52 +222,52 @@ public class Item implements ITaggable<Item>, IItemConvertible
     /**
      * Called before a block is destroyed with this item. If the return value is false, the block won't be destroyed
      */
-    public boolean beforeDestroyBlock(World world, ItemStack itemStack, int blockId, int x, int y, int z, Side side, Player player)
+    public boolean beforeDestroyBlock(final World world, final ItemStack itemStack, final int blockId, final int x, final int y, final int z, final Side side, final Player player)
     {
     	return true;
     }
 
-    public boolean onBlockDestroyed(World world, ItemStack itemstack, int removedBlockId, int x, int y, int z, Side side, Mob mob)
+    public boolean onBlockDestroyed(final World world, final ItemStack itemstack, final int removedBlockId, final int x, final int y, final int z, final Side side, final Mob mob)
     {
         return false;
     }
 
-    public int getDamageVsEntity(Entity entity, ItemStack itemStack)
+    public int getDamageVsEntity(final Entity entity, final ItemStack itemStack)
     {
         return 1;
     }
 
-    public boolean canHarvestBlock(Mob mob, ItemStack itemStack, Block<?> block)
+    public boolean canHarvestBlock(final Mob mob, final ItemStack itemStack, final Block<?> block)
     {
         return false;
     }
 
-    public boolean useItemOnEntity(ItemStack itemstack, Mob mob, Player player)
+    public boolean useItemOnEntity(final ItemStack itemstack, final Mob mob, final Player player)
     {
         return false;
     }
 
-    public Item setKey(String s)
+    public Item setKey(final String s)
     {
-        key = "item." + s;
-        nameToIdMap.put(key, this.id);
+        this.key = "item." + s;
+        nameToIdMap.put(this.key, this.id);
         return this;
     }
 
     public String getKey()
     {
-        return key;
+        return this.key;
     }
 
-    public String getLanguageKey(ItemStack itemstack)
+    public String getLanguageKey(final ItemStack itemstack)
     {
-        return key;
+        return this.key;
     }
-    public String getTranslatedName(ItemStack itemstack) {
+    public String getTranslatedName(final ItemStack itemstack) {
         return I18n.getInstance().translateKey(itemstack.getItemKey() + ".name");
     }
 
-    public String getTranslatedDescription(ItemStack itemstack) {
+    public String getTranslatedDescription(final ItemStack itemstack) {
         return I18n.getInstance().translateKey(itemstack.getItemKey() + ".desc");
     }
 
@@ -273,26 +275,26 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return new CompoundTag();
     }
 
-    public Item setContainerItem(Item item)
+    public Item setContainerItem(final Item item)
     {
-        if(maxStackSize > 1)
+        if(this.maxStackSize > 1)
         {
             throw new IllegalArgumentException("Max stack size must be 1 for items with crafting results");
         } else
         {
-            containerItem = item;
+            this.containerItem = item;
             return this;
         }
     }
 
     public Item getContainerItem()
     {
-        return containerItem;
+        return this.containerItem;
     }
 
     public boolean hasContainerItem()
     {
-        return containerItem != null;
+        return this.containerItem != null;
     }
 
     public String getStatName()
@@ -300,11 +302,11 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return I18n.getInstance().translateKey(getKey() + ".name");
     }
 
-    public void inventoryTick(ItemStack itemstack, World world, Entity entity, int slotId, boolean flag)
+    public void inventoryTick(final ItemStack itemstack, final World world, final Entity entity, final int slotId, final boolean flag)
     {
     }
 
-    public void onCraftedBy(ItemStack itemstack, World world, Player entityplayer)
+    public void onCraftedBy(final ItemStack itemstack, final World world, final Player entityplayer)
     {
     }
 
@@ -317,7 +319,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
     	return false;
     }
 
-    public ItemStack onInventoryInteract(Player player, Slot slot, ItemStack stackInSlot, boolean isItemGrabbed) {
+    public ItemStack onInventoryInteract(final Player player, final Slot slot, final ItemStack stackInSlot, final boolean isItemGrabbed) {
     	return stackInSlot;
     }
 
@@ -326,7 +328,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
     }
 
     @Override
-    public boolean isIn(Tag<Item> tag) {
+    public boolean isIn(final Tag<Item> tag) {
         return tag.appliesTo(this);
     }
 
@@ -340,14 +342,14 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return new ItemStack(this);
     }
 
-    public static boolean hasTag(ItemStack itemStack, Tag<Item> tag) {
+    public static boolean hasTag(final ItemStack itemStack, final Tag<Item> tag) {
     	if(itemStack == null) {
     		return false;
     	}
     	return tag.appliesTo(itemsList[itemStack.itemID]);
     }
     @Nullable
-    public static Item getItem(int id) {
+    public static Item getItem(final int id) {
         return itemsList[Math.max(id, 0)];
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
index 1937dc62b..0a31d74d1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
@@ -1,5 +1,9 @@
 package net.minecraft.core.item;
 
+import it.unimi.dsi.fastutil.ints.Int2IntMap;
+import it.unimi.dsi.fastutil.ints.Int2IntOpenHashMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.block.material.Material;
@@ -23,7 +27,7 @@ import java.util.Map;
 
 public class ItemMap extends Item implements IComplexItem
 {
-	private static final Map<Integer, Map<Integer, Integer>> blockCounts = new HashMap<>();
+	private static final Int2ObjectMap<Int2IntMap> blockCounts = new Int2ObjectOpenHashMap<>();
     protected ItemMap(String name, String namespaceId, int id)
     {
         super(name, namespaceId, id);
@@ -201,10 +205,10 @@ public class ItemMap extends Item implements IComplexItem
 					int rand = blockX + blockZ * 0x389bf;
 					rand = rand * rand * 0x1dd6751 + rand * 11;
 					if((rand >> 20 & 1) == 0) {
-						blockCounts.putIfAbsent(Blocks.DIRT.id(), new HashMap<>());
+						if (!blockCounts.containsKey(Blocks.DIRT.id())) blockCounts.put(Blocks.DIRT.id(), new Int2IntOpenHashMap());
 						blockCounts.get(Blocks.DIRT.id()).put(-1, blockCounts.get(Blocks.DIRT.id()).getOrDefault(-1, 0) + 10);
 					} else {
-						blockCounts.putIfAbsent(Blocks.STONE.id(), new HashMap<>());
+						if (!blockCounts.containsKey(Blocks.STONE.id())) blockCounts.put(Blocks.STONE.id(), new Int2IntOpenHashMap());
 						blockCounts.get(Blocks.STONE.id()).put(-1, blockCounts.get(Blocks.STONE.id()).getOrDefault(-1, 0) + 10);
 					}
 					pixelHeight = 100D;
@@ -237,7 +241,7 @@ public class ItemMap extends Item implements IComplexItem
 							}
 							pixelHeight += (double) height / (double) (blocksPerPixel * blocksPerPixel);
                             int meta = chunk.getBlockMetadata(_x + blockInChunkX, height, _z + blockInChunkZ);
-							blockCounts.putIfAbsent(id, new HashMap<>());
+							if (!blockCounts.containsKey(id)) blockCounts.put(id, new Int2IntOpenHashMap());
 							blockCounts.get(id).put(-1, blockCounts.get(id).getOrDefault(-1, 0) + 1);
 							blockCounts.get(id).put(meta, blockCounts.get(id).getOrDefault(meta, 0) + 1);
 						}
@@ -249,9 +253,9 @@ public class ItemMap extends Item implements IComplexItem
 				
 				int max = 0;
 				int id = 0;
-				for (Map.Entry<Integer, Map<Integer, Integer>> e : blockCounts.entrySet()){
+				for (Int2ObjectMap.Entry<Int2IntMap> e : blockCounts.int2ObjectEntrySet()){
 					if (e.getValue().getOrDefault(-1, -1) > max){
-						id = e.getKey();
+						id = e.getIntKey();
 						max = e.getValue().get(-1);
 					}
 				}
